=== debian/control ===
Source: caffe-contrib
Section: contrib/science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Zhou Mo <cdluminate@gmail.com>
Build-Depends: bc,
               cmake,
               bash-completion,
               debhelper (>=10),
               dh-python,
               git,
# libboost-all-dev (>= 1.55) - we merely pull partial boost stack, the really needed part.
               libboost-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libboost-python-dev,
               libgflags-dev,
               libgoogle-glog-dev,
               libhdf5-dev,
               libleveldb-dev,
               liblmdb-dev,
# switch libblas.so.3 between Atlas and OpenBLAS with update-alternatives
               libblas-dev | libblas.so,
               libopencv-dev (>= 2.4),
               libprotobuf-dev,
               libprotoc-dev,
               libsnappy-dev,
               protobuf-compiler,
# python3 depssome of them are not B-D but we need them as runtime-deps to pass the testsuite
               python3-dev,
               python3-numpy,
               cython3,
               ipython3,
               python3,
               python3-skimage,
               python3-protobuf,
               python3-dateutil,
               python3-gflags,
               python3-h5py,
               python3-leveldb,
               python3-matplotlib,
               python3-networkx,
               python3-nose,
#              python3-opencv, # this is recommended if available but it doesn't block
               python3-pandas,
               python3-pil,
               python3-scipy,
               python3-six,
               python3-yaml,
# The above part is synced with main/caffe
# The following part is CUDA related B-D
               nvidia-cuda-toolkit (>= 7.5.18) [amd64 ppc64el],
               clang-3.8,
Standards-Version: 3.9.8
Homepage: http://caffe.berkeleyvision.org
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/caffe-contrib.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/caffe-contrib.git
X-Python-Version: >= 3.3

Package: caffe-cuda
Section: contrib/metapackages
Architecture: amd64 ppc64el
Depends: caffe-tools-cuda   (= ${binary:Version}),
         python3-caffe-cuda (= ${binary:Version}),
         libcaffe-cuda1     (= ${binary:Version}),
# the default libblas.so.3 comes from pkg:libblas3, with low performance.
         libopenblas-base | libatlas3-base | libblas.so.3 ,
         ${misc:Depends},
Suggests: libcaffe-cuda-dev  (= ${binary:Version}),
          caffe-doc,
Conflicts: caffe-cpu
Description: Fast, open framework for Deep Learning (Meta)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 This metapackage pulls CUDA version of caffe:
  * caffe-tools-cuda
  * libcaffe-cuda*
  * python3-caffe-cuda
 And suggests these packages:
  * libcaffe-cuda-dev
  * caffe-doc
 .
 Note, this CUDA version cannot co-exist with the CPU_ONLY version.

Package: caffe-tools-cuda
Architecture: amd64 ppc64el
Multi-Arch: foreign
Depends: libcaffe-cuda1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: caffe-tools-cpu
Description: Tools for fast, open framework for Deep Learning (CUDA)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 It contains caffe executables, configured with CUDA.

Package: libcaffe-cuda1
Section: contrib/libs
Architecture: amd64 ppc64el
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libcaffe-cpu1
Description: library of Caffe, deep leanring framework (CUDA)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 It contains caffe shared library, configured with CUDA.

Package: libcaffe-cuda-dev
Section: contrib/libdevel
Architecture: amd64 ppc64el
Multi-Arch: foreign
Depends: libcaffe-cuda1 (= ${binary:Version}), ${misc:Depends}
Conflicts: libcaffe-cpu-dev
Suggests: caffe-doc
Description: development files for Caffe (CUDA)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 It contains the development files of caffe.

Package: python3-caffe-cuda
Section: contrib/python
Architecture: amd64 ppc64el
Multi-Arch: foreign
Depends: libcaffe-cuda1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends},
Conflicts: python3-caffe-cpu
Description: Python3 interface of Caffe (CUDA)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 It contains the CUDA version of python3 Caffe interface.

# caffe-doc is built by main/caffe, the CPU version.
