## caffe-contrib 1.0.0

=== debian/changelog ===
caffe-contrib (1.0.0-6build1) bionic; urgency=medium

  * No-change rebuild against CUDA 9.1

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 05 Mar 2018 19:04:33 +0000

caffe-contrib (1.0.0-6) unstable; urgency=medium

  * Add a commented patch from ubuntu.
  * Bump debhelper compat to 11.
  * Bump Standards-Version to 4.1.3 (no change).
  * Point Vcs-* fields to Salsa.
  * Don't hardcode python3.5 in the patch.
  * Fix insecure-copyright-format-uri.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 27 Jan 2018 09:55:40 +0000

caffe-contrib (1.0.0-5) unstable; urgency=medium

  * Apply updates from upstream master branch.
    - Remove merged patch cmake-change-static-lib-name.patch.
  * Add patch to deprecate old GPU archs.
    + cmake-deprecate-old-gpu-arch.patch
  * Build with GCC-6 and CUDA9.0 .
  * Add temporary fix for boost1.62 + CUDA9.0 .
    + fix-compat-boost-cuda.patch

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 23 Jan 2018 13:39:15 +0000

caffe-contrib (1.0.0-4) unstable; urgency=medium

  * Change compiler from Clang-3.8 back to GCC-5. (Closes: #871232, #873405)
    Although the GCC-5 removal will trigger a new RC bug, however at
    least this change makes the package buildable.
  * Update my name in control and copyright.
  * Bump Standards-Version to 4.1.1 . No change needed.
  * Use dh_missing --list-missing instead of dh_install --list-missing.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 26 Oct 2017 05:07:43 +0000

caffe-contrib (1.0.0-3) unstable; urgency=medium

  * Upload to unstable.
  * Set multi-arch of the dev package to same.
  * Bump Standards Version to 4.0.0 (needs no change).

 -- Zhou Mo <cdluminate@gmail.com>  Tue, 04 Jul 2017 09:47:52 +0000

caffe-contrib (1.0.0-2) experimental; urgency=medium

  * Rename static library libproto.a -> libcaffeproto.a and add it back
    to the -dev package. (Closes: #862528)

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 15 May 2017 02:12:33 +0000

caffe-contrib (1.0.0-1) experimental; urgency=medium

  * New upstream release. (packaging synchronized with src:caffe)
  * Patchset update:
    - Remove post_rc5_upstream_updates.patch (included in upstream).
    - Remove cmake-using-gnuinstalldirs (merged).
    - Remove fix-more-float-comparison-precision-issue (merged).
  * Rules: update CAFFE_SOLVER and get-orig-source accordingly.
  * Control:
    + Add new dependency: python3-pydotplus .
    + Update description: upstream Lab renamed from BVLC to BAIR.

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 01 May 2017 01:32:29 +0000

caffe-contrib (1.0.0~rc5-1) experimental; urgency=medium

  * New upstream RC release.
  * Update CAFFE_SOLVER and get-orig-source target in rules.
  * Update patchset (synchronized from src:caffe package):
    - Remove cmake-avoid-argument-missing, cmake-bump-soversion-to-rc4.patch .
    - Refresh the other patches.
    - Cherry-pick upstream updates to rc5: post_rc5_upstream_updates.patch .

 -- Zhou Mo <cdluminate@gmail.com>  Sun, 09 Apr 2017 14:51:50 +0000
