=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: contrib/science
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Zhou Mo <cdluminate@gmail.com>
+Uploaders: Mo Zhou <cdluminate@gmail.com>
 Build-Depends: bc,
                cmake,
                bash-completion,
-               debhelper (>=10),
+               debhelper (>=11~),
                dh-python,
                git,
 # libboost-all-dev (>= 1.55) - we merely pull partial boost stack, the really needed part.
@@ -45,17 +45,19 @@
 #              python3-opencv, # this is recommended if available but it doesn't block
                python3-pandas,
                python3-pil,
+               python3-pydotplus,
                python3-scipy,
                python3-six,
                python3-yaml,
 # The above part is synced with main/caffe
 # The following part is CUDA related B-D
-               nvidia-cuda-toolkit (>= 7.5.18) [amd64 ppc64el],
-               clang-3.8,
-Standards-Version: 3.9.8
+               nvidia-cuda-toolkit (>= 9.0.176) [amd64 ppc64el],
+               gcc-6,
+               g++-6,
+Standards-Version: 4.1.3
 Homepage: http://caffe.berkeleyvision.org
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/caffe-contrib.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/caffe-contrib.git
+Vcs-Browser: https://salsa.debian.org/science-team/caffe-contrib
+Vcs-Git: https://salsa.debian.org/science-team/caffe-contrib.git
 X-Python-Version: >= 3.3
 
 Package: caffe-cuda
@@ -72,8 +74,8 @@
 Conflicts: caffe-cpu
 Description: Fast, open framework for Deep Learning (Meta)
  Caffe is a deep learning framework made with expression, speed,
- and modularity in mind. It is developed by the Berkeley Vision
- and Learning Center (BVLC) and community contributors.
+ and modularity in mind. It is developed by the Berkeley AI Research
+ Lab (BAIR) and community contributors.
  .
  This metapackage pulls CUDA version of caffe:
   * caffe-tools-cuda
@@ -94,8 +96,8 @@
 Conflicts: caffe-tools-cpu
 Description: Tools for fast, open framework for Deep Learning (CUDA)
  Caffe is a deep learning framework made with expression, speed,
- and modularity in mind. It is developed by the Berkeley Vision
- and Learning Center (BVLC) and community contributors.
+ and modularity in mind. It is developed by the Berkeley AI Research
+ Lab (BAIR) and community contributors.
  .
  It contains caffe executables, configured with CUDA.
 
@@ -107,22 +109,22 @@
 Conflicts: libcaffe-cpu1
 Description: library of Caffe, deep leanring framework (CUDA)
  Caffe is a deep learning framework made with expression, speed,
- and modularity in mind. It is developed by the Berkeley Vision
- and Learning Center (BVLC) and community contributors.
+ and modularity in mind. It is developed by the Berkeley AI Research
+ Lab (BAIR)and community contributors.
  .
  It contains caffe shared library, configured with CUDA.
 
 Package: libcaffe-cuda-dev
 Section: contrib/libdevel
 Architecture: amd64 ppc64el
-Multi-Arch: foreign
+Multi-Arch: same
 Depends: libcaffe-cuda1 (= ${binary:Version}), ${misc:Depends}
 Conflicts: libcaffe-cpu-dev
 Suggests: caffe-doc
 Description: development files for Caffe (CUDA)
  Caffe is a deep learning framework made with expression, speed,
- and modularity in mind. It is developed by the Berkeley Vision
- and Learning Center (BVLC) and community contributors.
+ and modularity in mind. It is developed by the Berkeley AI Research
+ Lab (BAIR) and community contributors.
  .
  It contains the development files of caffe.
 
@@ -137,8 +139,8 @@
 Conflicts: python3-caffe-cpu
 Description: Python3 interface of Caffe (CUDA)
  Caffe is a deep learning framework made with expression, speed,
- and modularity in mind. It is developed by the Berkeley Vision
- and Learning Center (BVLC) and community contributors.
+ and modularity in mind. It is developed by the Berkeley AI Research
+ Lab (BAIR) and community contributors.
  .
  It contains the CUDA version of python3 Caffe interface.
