=== debian/rules ===
--- 
+++ 
@@ -7,11 +7,16 @@
 export DEB_CXXFLAGS_MAINT_APPEND = -Wall #-pedantic
 export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed
 
+# Try this if it fails to build with a new glibc.
+# Thanks to Gianfranco Costamagna <locutusofborg@debian.org>
+#export DEB_CFLAGS_MAINT_APPEND   = -Wall -D_GLIBCXX_USE_C99_MATH=1
+#export DEB_CXXFLAGS_MAINT_APPEND = -Wall -D_GLIBCXX_USE_C99_MATH=1
+
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 RULES         := debian/rules
-ORIG_SOURCE   := "https://github.com/BVLC/caffe/archive/rc4.tar.gz"
-CAFFE_SOVER   := 1.0.0-rc4
+ORIG_SOURCE   := "https://github.com/BVLC/caffe/archive/1.0.tar.gz"
+CAFFE_SOVER   := 1.0.0
 BUILDDIR      := "caffe_cuda_build"
 
 TEMPLATES     := $(wildcard debian/*.in)
@@ -39,14 +44,13 @@
 	-DUSE_OPENCV=ON \
 	-DCPU_ONLY=$(FILL_THIS_BLANK) \
 	-DCMAKE_INSTALL_PREFIX="/usr"
-# TODO: use CUDA arches suggested by nvidia people
 
 CONFFLAG_CUDA = \
 	$(CMAKE_CONFIGURE_TEMPLATE) \
 	-DCPU_ONLY=OFF \
 	-DCUDA_ARCH_NAME="All" \
-	-DCMAKE_CXX_COMPILER=clang++-3.8 \
-	-DCMAKE_C_COMPILER=clang-3.8
+	-DCMAKE_CXX_COMPILER=g++-6 \
+	-DCMAKE_C_COMPILER=gcc-6
 
 %:: %.in
 	perl -p \
@@ -77,18 +81,19 @@
 
 # In the test phase, we need to set LD_LIBRARY_PATH properly
 # for those test ELFs linked with libcaffe.so.X
-override_dh_auto_test: 
+override_dh_auto_test:
 	# the i386/amd64 build machine may have no CUDA-capable
 	# video card. Hence heading with a dash.
 	-dh_auto_test --builddirectory=$(BUILDDIR) \
-		-- runtest pytest LD_LIBRARY_PATH=$(shell pwd)/$(BUILDDIR)/lib/ 
+		-- runtest pytest LD_LIBRARY_PATH=$(shell pwd)/$(BUILDDIR)/lib/
 
 override_dh_python3:
 	dh_python3 --requires=python/requirements.txt
 	dh_numpy3
 
 override_dh_install:
-	dh_install --list-missing
+	dh_install
+	dh_missing --list-missing
 
 override_dh_auto_install:
 	dh_auto_install --builddirectory=$(BUILDDIR) -- install
@@ -103,4 +108,4 @@
 	chmod -x debian/tmp/usr/lib/python3/dist-packages/caffe/proto/__init__.py
 
 get-orig-source:
-	wget -c $(ORIG_SOURCE) -O caffe_1.0.0~rc4.orig.tar.gz
+	wget -c $(ORIG_SOURCE) -O caffe_1.0.0.orig.tar.gz
